#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
#$Id: deluser.pl,v 1.6.6.2 2001/12/10 23:36:32 ssmith Exp $
# 
# User._DESTROY handler
# author: Jonathan Mayer <jmayer@cobalt.com>

use strict;
use Sauce::Config;
use Sauce::Util;
use CCE;

my $cce = new CCE;
$cce->connectfd(\*STDIN,\*STDOUT);

# retreive user object data:
my $oid = $cce->event_oid();

my $old = $cce->event_old();

# verify that we're really deleting a user
if (!$oid ) {
	$cce->warn('[[base-user.Invalid-object]]');
	$cce->bye("FAIL");
}

# verify that the user exists
if (!getpwnam($old->{name})) {
	$cce->warn("[[base-user.Already-Destroyed,name=".$old->{name}."]]");
	# already destroyed?
	$cce->bye("SUCCESS");
}

# delete this user's EmailAlias object
Sauce::Util::editfile( '/etc/mail/aliases',
	\&Sauce::Util::replace_unique_entries,
	$oid, {} );

# clean the smbpasswd file
# FIXME

# clean the netatalk passwd file
# FIXME

# clean the htpasswd file
# FIXME

# clean the alias list and vacation stuff
# FIXME

# kill all of this user's currently running processes:
my @pids;
chomp (@pids = `/bin/ps --user $old->{name} -ho pid`);
if (@pids) {
	kill 1, @pids;
	sleep(1);
	my $cnt = 0;
	while (chomp(@pids = `/bin/ps --user $old->{name} -ho pid`)) {
		$cnt++;
		if ($cnt > 5) {
			print STDERR "$0: Couldn't kill processes of $old->{name}: @pids\n";
			last;
		}
		kill 9, @pids;
		sleep(1);
	}
}

# clean the password file
system("/usr/sbin/userdel", "-r", $old->{name});

# update workgroups
update_workgroups();

sub update_workgroups
{
	my @oids = $cce->find("Workgroup", { 'members' => $old->{name} });
	foreach my $oid (@oids) {
		my ($ok, $obj) = $cce->get($oid);
		my (@members) = $cce->scalar_to_array($obj->{members});
		@members = grep {$_ ne $old->{name}} @members;
		$cce->set($oid, "", { 'members' =>
			$cce->array_to_scalar(@members) } );
	}
}


$cce->bye("SUCCESS");
exit 0;



