#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
#$Id: etchosts.pl,v 1.3 2000/08/08 08:03:05 jmayer Exp $

use strict;
use Sauce::Config;
use Sauce::Util;
use CCE;

my $cce = new CCE;
$cce->connectfd(\*STDIN,\*STDOUT);

# get system and network object ids:
my ($system_oid) = $cce->find("System");
my @network_oids = $cce->find("Network");

# get system object:
my ($ok, $obj) = $cce->get($system_oid);
if (!$ok) { 
	# FIXME: fail
}

# get all network objects:
my @networks = ();
{
  my %nets = ();
  foreach $_ (@network_oids) {
	  my ($ok, $obj) = $cce->get($_);
    if ($ok) { $nets{$obj->{device}} = $obj; }
  }
  foreach $_ (sort keys %nets)
  {
  	push (@networks, $nets{$_});
  }
}

# munge hostname
my ($hostname, $domainname);
$hostname = $obj->{hostname};
$domainname= $obj->{domainname};
$hostname =~ s/\.${domainname}$//;
my $name = $obj->{hostname};

my $etchosts = <<EOT ;
# /etc/hosts
# Auto-generated file.  Keep your customizations at the bottom of this file.
127.0.0.1		localhost localhost.localdomain
EOT
if ($_ = shift(@networks)) {
	$etchosts .= $_->{ipaddr} ."\t\t${hostname}.${domainname} ${hostname}\n";
}
# this is probably optional:
foreach $_ (@networks) {
	my $dev = $_->{device};
	if ($_->{ipaddr}) {
	   $etchosts .= $_->{ipaddr} . "\t\t${hostname}-${dev}.${domainname} ${hostname}-${dev}\n";
	} else {
	   $etchosts .= "# $dev has not been configured.\n";
        }
}
$etchosts .= <<EOT ;
#END of auto-generated code.  Customize beneath this line.
EOT

# update /etc/hosts
{
  my $fn = sub {
    my ($fin, $fout) = (shift,shift);
    my ($text) = (shift);
    print $fout $text;
    my $flag = 0;
    while (defined($_ = <$fin>)) {
    	if ($flag) { print $fout $_; }
      else { if (m/^#END/) { $flag = 1; } }
    }
    return 1;
  };
  Sauce::Util::editfile('/etc/hosts', $fn, $etchosts);
  chmod(0644,'/etc/hosts');
};

$cce->bye('SUCCESS');
exit(0);

