#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
# $Id: etcresolv.pl,v 1.4 2000/06/11 01:58:09 kevin Exp $
# updates /etc/resolve
#
# depends on:
#		System.dns  (formated as a :-delimited list of DNS servers)
#		System.domainname

use strict;
use Sauce::Config;
use Sauce::Util;
use CCE;

my $cce = new CCE;
$cce->connectfd(\*STDIN,\*STDOUT);

# get system and network object ids:
my ($system_oid) = $cce->find("System");

# get system object:
my ($ok, $obj) = $cce->get($system_oid);
if (!$ok) { 
	# FIXME: fail
}

# get list of dns servers
my @dns = CCE->scalar_to_array($obj->{dns});
my $dom = $obj->{domainname};

# target file
my $fileName = '/etc/resolv.conf';

my $etchosts = <<EOT ;
# /etc/resolv.conf
# Auto-generated file.  Keep your customizations at the bottom of this file.
EOT
my $dns;
foreach $dns (@dns) {
	$etchosts .= "nameserver $dns\n";
};
$etchosts .= <<EOT ;
search $dom
domain $dom
#END of auto-generated code.  Customize beneath this line.
EOT

# update file
{
  my $fn = sub {
    my ($fin, $fout) = (shift,shift);
    my ($text) = (shift);
    print $fout $text;
    my $flag = 0;
    while (defined($_ = <$fin>)) {
    	if ($flag) { print $fout $_; }
    	else { if (m/^#END/) { $flag = 1; } }
    }
    return 1;
  };
  Sauce::Util::editfile($fileName, $fn, $etchosts );
};

# always make sure permission is right
chmod(0644, $fileName);

$cce->bye('SUCCESS');
exit(0);

